############################################################################
#
#       Project		GP calc program using MODIFIED gpquick-2.1,
# 			using UCL GNU/Unix/etc $Revision: 1.2 $ 
#	    
#       Author		W.Langdon
#
#	Created		26 Nov 1995, based upon calc2.make Revision: 1.1
# 									   
#	Modifications:  
#
#	Module:         calc.make
#
#	Description:          
#
#	FLAGS:     	-DTWOD?
#			-DDEBUG, if debugging messages should pop up?
#
#	Notes		ensure pch.h contain #define UNIX
#			calc.h #define MULTREE
#
############################################################################

NAME 	= GPcalc
OBJS 	= gp.o  calc.o  test.o stats.o  pareto.o	time.o	chrome.o   primitiv.o   Primitives.o  selector.o
LIBS 	= -lg++ -lm
CC 	= gcc
COMPILE = $(CC) -c $(CFLAGS)
CFLAGS 	= -ansi -O2 -Wall -Winline
#CFLAGS	= -ansi -O2 -Wno-import -W -Wimplicit -Wreturn-type -Wunused\
#-Wswitch -Wcomment -Wtrigraphs -Wformat -Wchar-subscripts \
#-Wuninitialized -Wparentheses -Wtemplate-debugging\
#-Winline 
#CFLAGS = -pg -O2 -fkeep-inline-functions -ansi -g -Wall
LINK 	= $(CC) -o 
LDFLAGS =  -Wall -g
#LDFLAGS = -pg -g -static


$(NAME):$(OBJS) 
	$(LINK) $(NAME) $(LDFLAGS) $(OBJS) $(LIBS)

#C++ source files

gp.o:	gp.cc pch.h chrome.h selector.h calc.h primitiv.h Primitives.h time.h gp.h test.h
	$(COMPILE) gp.cc

calc.o:	calc.cc pch.h chrome.h selector.h calc.h primitiv.h time.h Primitives.h gp.h test.h 
	$(COMPILE) calc.cc

test.o:	test.cc pch.h chrome.h selector.h calc.h time.h test.h Primitives.h gp.h test.run.cc test.fitness.cc 
	$(COMPILE) test.cc

stats.o:	stats.cc pch.h chrome.h selector.h calc.h gp.h
	$(COMPILE) stats.cc

pareto.o:	pareto.cc pch.h chrome.h selector.h calc.h Primitives.h time.h gp.h
	$(COMPILE) pareto.cc

time.o:		time.cc pch.h chrome.h selector.h calc.h time.h gp.h
	$(COMPILE) time.cc

chrome.o:	chrome.cxx pch.h chrome.h selector.h calc.h
	$(COMPILE) chrome.cxx

primitiv.o:	primitiv.cxx pch.h chrome.h selector.h calc.h time.h primitiv.h
	$(COMPILE) primitiv.cxx

Primitives.o:	Primitives.cc pch.h chrome.h selector.h calc.h time.h Primitives.h gp.h
	$(COMPILE) Primitives.cc

#stack_prim.o:	stack_prim.cc pch.h chrome.h selector.h calc.h stack_prim.h
#	$(COMPILE) stack_prim.cc

selector.o:	selector.cxx pch.h selector.h
	$(COMPILE) selector.cxx
