############################################################################
#
#       Project		GP list program using MODIFIED gpquick-2.1,
# 			using UCL GNU/Unix/etc $Revision: 1.15 $ 
#	    
#       Author		W.Langdon
#
#	Created		24 January 1995, based upon queue2.make Revision: 1.4
# 									   
#	Modifications:  
#
#	Module:         list.make
#
#	Description:          
#
#	FLAGS:     	-DTWOD?
#			-DDEBUG, if debugging messages should pop up?
#
#	Notes		ensure pch.h contain #define UNIX
#			chrome.h #define MULTREE
#
############################################################################

NAME 	= GPlist
OBJS 	= gp.o  list.o  test.o stats.o  pareto.o  time.o trace.o chrome.o   primitiv.o   Primitives.o  selector.o   
LIBS 	= -lg++ -lm
CC 	= gcc
COMPILE = $(CC) -c $(CFLAGS)
CFLAGS 	= -ansi -O2 -Wall -Winline
#CFLAGS	= -ansi -O2 -Wno-import -W -Wimplicit -Wreturn-type -Wunused\
#-Wswitch -Wcomment -Wtrigraphs -Wformat -Wchar-subscripts \
#-Wuninitialized -Wparentheses -Wtemplate-debugging\
#-Winline 
#CFLAGS = -pg -O2 -fkeep-inline-functions -ansi -g -Wall
LINK 	= $(CC) -o 
LDFLAGS =  -Wall -g
#LDFLAGS = -pg -g -static


$(NAME):$(OBJS) 
	$(LINK) $(NAME) $(LDFLAGS) $(OBJS) $(LIBS)

#C++ source files

gp.o:	gp.cc pch.h chrome.h selector.h list.h primitiv.h Primitives.h time.h gp.h trace.h test.h
	$(COMPILE) gp.cc

list.o:	list.cc pch.h chrome.h selector.h list.h primitiv.h time.h Primitives.h gp.h trace.h test.h
	$(COMPILE) list.cc

test.o:	test.cc pch.h chrome.h selector.h list.h test.h Primitives.h time.h gp.h trace.h test.run.cc test.fitness.cc
	$(COMPILE) test.cc

stats.o:	stats.cc pch.h chrome.h selector.h list.h gp.h trace.h
	$(COMPILE) stats.cc

pareto.o:	pareto.cc pch.h chrome.h selector.h list.h Primitives.h time.h gp.h trace.h
	$(COMPILE) pareto.cc

time.o:		time.cc pch.h chrome.h selector.h list.h time.h gp.h trace.h 
	$(COMPILE) time.cc

trace.o:	trace.cc pch.h chrome.h selector.h list.h Primitives.h time.h gp.h trace.h 
	$(COMPILE) trace.cc

chrome.o:	chrome.cxx pch.h chrome.h selector.h list.h
	$(COMPILE) chrome.cxx

primitiv.o:	primitiv.cxx pch.h chrome.h selector.h list.h time.h primitiv.h
	$(COMPILE) primitiv.cxx

Primitives.o:	Primitives.cc pch.h chrome.h selector.h list.h Primitives.h time.h gp.h trace.h
	$(COMPILE) Primitives.cc

selector.o:	selector.cxx pch.h selector.h
	$(COMPILE) selector.cxx
