// queue.cc   File to demonstrate evolution of queue, build with GPQUICK-2.1
// W. Langdon cs.ucl.ac.uk 25 June 1994
//                     based upon queue.cc 24 Jun 1994,c Revision: 1.6.1.4
#define main_version "29 Nov 1994 $Revision: 1.58 $"

// Includes main function


//Modifications (in reverse order)

//WBL 31 Mar 97  Make compatible with GPxxx framework (but dont intergrate)
//               (Also restore r1.56 ie 320 tests rather than 32000)
//               Make compatible with DEC ALPHA C

//WBL 29 Nov 94  Add command line handling

//WBL 25 Nov 94  Comment out all calls to test_all_adf1.
//               Display location and scores of all "best" progs in pop

//WBL 23 Nov 94  Display all non-zero results from Is_adf1_minc rather >= 10

//WBL 23 Nov 94  Make Is_adf1_minc return length of cycle, rather than total

//WBL 22 Nov 94  Rule out answers < -15 or >15 in Is_adf1_minc. Plus bugfix

//WBL 22 Nov 94  Restore version 21 Oct 1994  ??
//               Add Is_adf1_minc() and test_all_adf1

//WBL 21 Oct 94  Same test sequence as before
//               Gather and display Adf1 cache statistics

//WBL 20a Oct 94 Ensure updates to store by Adf1 are recorded in store_written

//WBL 20 Oct 94  Add results cache to Adf1 (speed and better adf1ver display)

//WBL 19 Oct 94  Reduce size of numbers enqueued by 5/15.7
//               Count only store[] elements written to when counting mem used
//               Remove memory component of fitness
//               Add calling queue::Fitness before display_run if gp.load

//WBL 15aOct 94  Facility to load one chrome. Add TreeNameMatch

//WBL 15 Oct 94  Revert to 1.38 (ie restore empty)
//               To reduce file size: Remove display of average test passes

// WBL 13 Oct 94 Make static_check() forbid poor functions, do more checks,
//               Change check so all inputs must return different output
//               Treat adf1 as semantic variability of Adf1 instead of bad flag

// WBL 13 Sep 94 Make static_check() and write() maintain adf1

// WBL 13 Sep 94 Make compilable by solaris gcc

// WBL 13 Sep 94 Reimplement static_check to simply compare answers.
//               Remove memory_penalty, arg1_used and arg1_side_effect

// WBL 13 Sep 94 Remove Aux3 and Inc_Aux<n>

// WBL 7B Sep 94 Remove ADF1 from makenul

// WBL 7A Sep 94 Reduce store size from 63 to 31 cells

// WBL 7 Sep 94  Discarded version 6 Sep 94. Implement via last_var_used insted
//               Retain Dont allow fron and empty to call Adf

// WBL 1 Sep 94  Remove (use of) MInc<n>

// WBL 31b Aug 94 Make MIncN consistent with Mod (ie for -ve)

// WBL 31a Aug 94 Remove again..Restore write_tests every gen
//               Dont allow set_auxN, except in Makenull
//               Dont allow IncN, DecN or write in Empty or Front
//               Add MInc1, MInc2 and MInc3 (If it wont learn; tell it)

// WBL 29 Aug 94 For test 5 scale proability of enqueue according to q length
//               and adjust priorities to get even spread of tests by qlen
//               DONT Call write_tests every gen
//               Correct wordsused() and its usage. Move mem_penalty_bot to Q.h

// WBL 27 Aug 94 Half way for enqueue(number)
//               Remove Prog3 and Qrog3
//               1st 5 tests(add Last_test_seq, replace num_tests by test_total
//               Move write_tests to end of run, display number of passes etc


// WBL 25 Aug 94 Remove abort on memory out of range.
//               Restrict which primitives can be in which tree
//               Add Aux3, allow dequeue to call front, remove aux1--, aux2--
//               Increase number of enqueue(small number)
//               Comment per gen display of best

// WBL 24 Aug 94 Move to class queue to queue.h Add passed and if passed all 
//               setting score = max_fitness

// WBL 23 Aug 94 Move to Pareto tournament selection. Add queue.h
//               Move hits from Chrome to new Problem specific class
//               FitnessValue. Make ThisProblem of type queue*.
//               Add wordsused() and use it. Use fitptr inplace of chr..->nfi..

// WBL 16 Aug 94 Add Prog2, Prog3, Qrog2 and Qrog4

// WBL 15 Aug 94 Undo 7 Aug 94 (quick and dirty). Move setting max_fitness
//               to generate_tests, move score(), move display of fitness
//               targets from write_tests to main.
//               Keep record of how many tests we pass.

// WBL  5 Aug 94 Boost penalty from .2 to 2

// WBL  5 Aug 94 Add penalty for using more than 15 memory cells

// WBL  4 Aug 94 Increase 5th test from 80 to 160 tests

// WBL 3b Aug 94 Remove makenull from 5th test and boost chance of enqueue
//               Correct comparison of probabilities when choosing test

// WBL  3 Aug 94 Fix calculation of modulus again. See test program
//               mod_test.cc and its output file mod_final_test.
//               Nb retro fit 1.12 ontop of 1.9

// WBL 31 Jul 94 Increase chance of using small integers
//               Add 5th test sequence
//               FIXBUG in 30 Jul so display "start_test" correctly

// WBL 31 Jul 94 Add display of elapsed time

// WBL 30 Jul 94 Make number of test sequences to skip configurable
//               and restore all four.
//               Replace Write_Aux(n) with Set_Aux(n)
//               Remove Arg2 from function list (never non-zero)

// WBL  7 Jul 94 Skip first three test sequences

// WBL  6 Jul 94 Add ADF code from queue.cc version 2.6
//               But only allow adf1 to be called.
//               Add check NUM_TREES is correct

// WBL 30 Jun 94 Make calling  DisplayDstats() depend on pTrace bit 2 only

// WBL 28 Jun 94 Make calling  DisplayDstats() depend on pTrace
//               Give empty score of 1 rather than .25
//               Give front and dequeue score of 1 for correct

// WBL 27 Jun 94 Restore DisplayDstats()

// WBL 25 Jun 94 Make Dequeue return answer. Test on same basis as Front.
//	         Remove directing crossover. (25a correct Good score)

// WBL 24 Jun 94 Based on version 1.6 ie skip version which add ADFS
//               But add tidy ups.
//               Direct which tree will contain crossover points.

// WBL 19 Jun 94 Make all function scores parmaterisable. Make front score use
//               recipricol difference and sign, use empty_score rather than 1
//               use gencount+1 when deciding to stop or not

// WBL 17 Jun 94 Use same test lengths as stack.cc version 25 May 1994,3

// WBL 16 Jun 94 Add using pPopSeed and pTestSeed. Move Pop::Write()
//               Comment out Pop::DisplayDstats()

// WBL 14 Jun 94 Add calling Load() and Save() and drawing pop_size and 
//               gen_max from params.
//               Add calling Pop::DisplayDStats(), Pop::Write()

// WBL 13 Jun 94 Make empty == 0 => TRUE, rather than >0

//requires MULTREE to be defined

#include "pch.h"
#include "chrome.h"
#include "primitiv.h"

#include "queue2.h"

#include <assert.h>
//extern double difftime (time_t t2, time_t t1 );


extern char scratch[100];
#ifdef FASTEVAL
	extern evalnode* IpGlobal;
	extern Chrome* ChromeGlobal;
#endif

const float sign_score      = 0.0; //front & dequeue
const float magnitude_score = 1.0; //front & dequeue
const float empty_score     = 1.0;
const float makenull_score  = 0.05;
//          dequeue_score -- as front
const float enqueue_score   = 0.05;
      float max_fitness     = 0.0; // Calculated by write_tests
const float mem_penalty     = 0.0; // No longer used was 2.0;
//const int mem_penalty_bot = 16;

//**************************************************************************

// Define your FitnessValue class

void myfitnessvalue::write(ostream& fout)
{	fout << fvalue;
        int total = 0;
	fout << " {";
	for (int i=0; i <= empty; i++)
		{ total += hits[i];
		  fout << hits[i];
		  if (i < empty ) fout << ",";
	        }
	fout << "}= " << total;
	fout << " memory " << mem_used;
	fout << " adf1ver " << adf1;
}//end myfitnessvalue::write

queue* ThisProblem;
ChromeParams* ThisParams = new ChromeParams();

//**************************************************************************
// static variables that make up the evaluation environment
// Build your environment here as statics
// where the evaluation functions can get to the data

#define Num_test_seq       5
#define Last_test_seq      5
//#define num_tests        320
#define Max_tests        (320+Num_test_seq+1)

#define test_queue_limit  10
#define Max               10
#define store_limit       32

retval Arg1, Arg2, Aux1, Aux2, Aux3, store[store_limit];

BOOL store_written[store_limit];

#define Vnone (-4)
#define Vaux3 (-3)
#define Vaux2 (-2)
#define Vaux1 (-1)
//else store[x]
int last_var_used = Vnone;

int calls [ NUM_TREES]; //used to prevent recursive calls

BOOL memory_error;
BOOL recurse_error;

int get_address()
{
int address = (EVAL)+(store_limit/2);

if ( address <= 0 || address >= store_limit )
  {
	memory_error = TRUE;
	store[0] = 0;         //Prevent using buffer area (depends on write)
	return 0;             //safe buffer area
  }
else
  {	return address;
  }
}//end get_address
//**************************************************************************

class retval_cache
{
 private:
	retval* answerptr;
	int     cache_size /*= 0*/;
	/*const int magic = -50505050;*/ enum {magic = -50505050};
//statistics
	int     calls;
	int     hits;
	int     magic_hits;
	retval  min;
	retval  max;
 public:
	int cache_used /*= 0*/;
	retval_cache( int size ): cache_used(0) 
		{ 
//cout<<"retval_cache"<<endl;//debug
		  answerptr   = new retval [ size ]; 
	          cache_size  = size;
                  stats_init();
	        };
	~retval_cache() 
		{ 
//cout<<"deleting retval_cache"<<endl;//debug
		  delete[] answerptr;
	        }
	void init()
                { 
//cout<<"init cache"<<endl;//debug
                  cache_used = 0;
                  for (int i = 0; i < cache_size; i++)
			  answerptr[i] = magic;
                };
        BOOL held( retval input, retval* output )
                { calls++;
                  if ( input >= (0-cache_size/2) && input < cache_size/2 )
		      {
			      if ( answerptr[input+cache_size/2] == magic )
				      {return FALSE;};
			      hits++;
//cout<<"heldFound "<<input<<". Returning ";
//cout<<answerptr[input+cache_size/2]<<flush;
                              *output = answerptr[input+cache_size/2];
//cout<<" returned value="<<*output<<endl;
			      return TRUE;
		      }
//cout<<"held "<<input<<" outside cache "<<endl;
		  return FALSE;
                };
	void add( retval input, retval answer )
		{   if (input < min) min = input;
                    if (input > max) max = input;
//cout<<"Add "<<input<<","<<answer<<flush;
                    if ( input >= (0-cache_size/2) && input < cache_size/2 )
			   { if (answer==magic)
				  {  magic_hits++;}
			     else
				  {  answerptr[input+cache_size/2] = answer;
//cout<<". Slots in use "<<cache_used<<flush;
				      cache_used++;
			          }
		           }
//cout<<endl;//debug
	        };
	void stats_init();
	void write( ostream& fout = cout )
		{   fout << "Cache used "<< calls << " times, hits " << hits;
		    fout << " (" << float(hits)/float(calls) << ").";
		    fout << " Least input " << min;
		    fout << " highest input " << max;
		    fout << " magic number " << magic;
		    fout << " hit " << magic_hits << endl;
		};
};//end retval_cache
	
void retval_cache::stats_init()
{
	calls = 0;
	hits  = 0;
	magic_hits = 0;
	min   = MAXINT;
	max   = -MAXINT;
}

retval_cache adf1_cache(1000);

//**************************************************************************
/////////////////// Problem specific functions and terminals
// Use the OPDEF,EVAL,IP and CHROMEP defines
// and the code will recompile for different eval methods

// Problem Specific Terminals

// gcc refuses to accept these in primitiv So stuff em here!

OPDEF(Prog2Eval) {EVAL; return EVAL;}
//OPDEF(Prog3Eval) {EVAL;EVAL; return EVAL;}
OPDEF(Qrog2Eval) {retval first_eval=EVAL;
                  int    save_last_var_used = last_var_used;
		  EVAL;
		  last_var_used = save_last_var_used;
		  return first_eval;}
//OPDEF(Qrog3Eval) {retval first_eval=EVAL;EVAL;EVAL; return first_eval;}

OPDEF(zeroEval) {return 0;}
OPDEF(oneEval) {return 1;}
OPDEF(MaxEval) {return Max;}
OPDEF(modEval) { //see workbook III 10 June 1994
                 //    workbook IV  3 August 1994
       retval a = EVAL;
       retval b = abs(EVAL);
       if (b!=0) return (a % b + b) % b;
       else      return a;
}
OPDEF(Arg1Eval) {return Arg1;}
OPDEF(Arg2Eval) {return Arg2;}
OPDEF(Aux1Eval) {last_var_used=Vaux1; return Aux1;}
OPDEF(Aux2Eval) {last_var_used=Vaux2; return Aux2;}
OPDEF(Aux3Eval) {last_var_used=Vaux3; return Aux3;}
OPDEF(inc_Aux1Eval)  {last_var_used=Vaux1; return ++Aux1;}
OPDEF(Minc_Aux1Eval) {last_var_used=Vaux1; 
                      return Aux1 = ((++Aux1)%Max+Max)%Max;}
OPDEF(dec_Aux1Eval)  {last_var_used=Vaux1; return --Aux1;}

OPDEF(inc_Aux2Eval)  {last_var_used=Vaux2; return ++Aux2;}
OPDEF(Minc_Aux2Eval) {last_var_used=Vaux2;
                      return Aux2 = ((++Aux2)%Max+Max)%Max;}
OPDEF(dec_Aux2Eval)  {last_var_used=Vaux2; return --Aux2;}

OPDEF(inc_Aux3Eval)  {last_var_used=Vaux3; return ++Aux3;}
OPDEF(Minc_Aux3Eval) {last_var_used=Vaux3;
                      return Aux3 = ((++Aux3)%Max+Max)%Max;}
OPDEF(dec_Aux3Eval)  {last_var_used=Vaux3; return --Aux3;}

//Problem specific Functions
OPDEF(readEval) {
       int address = get_address();
       last_var_used = address;
       return store[address];
}
OPDEF(writeEval) {
       int address = get_address(); 
       retval old = store[address];
       store[address] = EVAL;
       store_written[address] = TRUE;
       last_var_used = address;
       return old;                // copy what Tesler does
}
//OPDEF(write_Aux1Eval) {
//       retval old = Aux1;
//       Aux1 = EVAL;
//       return old;                // copy what write (ie Tesler) does
//}
//OPDEF(write_Aux2Eval) {
//       retval old = Aux2;
//       Aux2 = EVAL;
//       return old;                // copy what write (ie Tesler) does
//}
OPDEF(set_Aux1Eval) {
       Aux1 = EVAL;
       last_var_used = Vaux1;
       return Aux1;                // Nb simplier than Tesler
}
OPDEF(set_Aux2Eval) {
       Aux2 = EVAL;
       last_var_used = Vaux2;
       return Aux2;                // Nb simplier than Tesler
}
OPDEF(set_Aux3Eval) {
       Aux3 = EVAL;
       last_var_used = Vaux3;
       return Aux3;                // Nb simplier than Tesler
}
retval calleval (int numarg, int tree, retval_cache* cache = NULL )
{
	retval result;

	int save_arg1 = Arg1;
	int save_arg2 = Arg2;
	int save_var_used = last_var_used;

	int t1 = 0;
	int t2 = 0;
	int var_used = Vnone;

	if ( numarg > 0 )
		{ last_var_used = Vnone; 
		  t1 = EVAL;
		  var_used = last_var_used;
	        }
	if ( numarg > 1 ) t2 = EVAL;
	assert ( numarg <= 2 ); 

	Arg1 = t1;
	Arg2 = t2;

	if ( calls [ tree ]++ > 1 )
	      { recurse_error = TRUE;
	        result = 0;
	      }
	else  { 
		if (cache==NULL || cache->held(Arg1,&result)==FALSE)
		{
			evalnode* save_ip = IP;
			result = CHROMEP->evalAll ( tree );
			IP = save_ip;
			if (cache!=NULL) cache->add(Arg1,result);
	        }
//cout<<"calleval updating "<<last_var_used<<" to "<<result<<endl;
		switch(last_var_used)
			{
			case Vnone:
				break;
			case Vaux1:
				Aux1 = result;
				break;
			case Vaux2:
				Aux2 = result;
				break;
			case Vaux3:
				Aux3 = result;
				break;
			default:
				if ( last_var_used > 0 &&
				     last_var_used < store_limit)
				    {
					store[last_var_used]         = result;
					store_written[last_var_used] = TRUE;
				    }
				break;
			}//end switch
	      }
	calls [ tree ]--;

	Arg1   = save_arg1;
	Arg2   = save_arg2;
	last_var_used = save_var_used;

	return result;

}//end calleval

OPDEF(MakenullEval) {return calleval (0,makenull);}
OPDEF(FrontEval)    {return calleval (0,front);}
OPDEF(DequeueEval)  {return calleval (0,dequeue);}
OPDEF(EnqueueEval)  {return calleval (1,enqueue);}
OPDEF(EmptyEval)    {return calleval (0,empty);}
OPDEF(Adf1Eval)     {return calleval (1,adf1,&adf1_cache);}
OPDEF(Adf2Eval)     {return calleval (2,adf2);}

//**************************************************************************
///////////////////////// PROBLEM definition


void queue::AddF1 (int t, Function* f )
{
AddF(f);
addtofuncbag(t, f);
}

void queue::AddFbar1 (int exclude_tree, Function* f )
{
AddF(f);
for ( int i = 0; i < NUM_TREES; i++ )
	{if ( i != exclude_tree) addtofuncbag(i, f);};
}

void queue::AddF2 (int t1, int t2, Function* f )
{
AddF(f);
addtofuncbag(t1, f);
addtofuncbag(t2, f);
}

void queue::AddF3 (int t1, int t2, int t3, Function* f )
{
AddF(f);
addtofuncbag(t1, f);
addtofuncbag(t2, f);
addtofuncbag(t3, f);
}

void queue::AddFmain (Function* f )
{
AddFbar1(adf1, f);
}

void queue::AddFall (Function* f )
{
AddFmain(f);
addtofuncbag(adf1, f);
}

queue::queue(ChromeParams* p) : Problem()
{
	assert ( NUM_TREES >= adf1+1);

	AddF(new ConstFunc(0));    // REQUIRED as function 0

	// Add some standard primitives
	AddFall(new AddFunc(100));
	AddFall(new SubFunc(100));

	AddFall(new Function(2,0,100,Prog2Eval,"PROG2"));
//	AddFall(new Function(3,0,100,Prog3Eval,"PROG3"));
	AddFall(new Function(2,0,100,Qrog2Eval,"QROG2"));
//	AddFall(new Function(3,0,100,Qrog3Eval,"QROG3"));

	// Add the problem specific primitives
	AddFall(new Function(0,0,100,zeroEval,"0"));
	AddFall(new Function(0,0,100,oneEval,"1"));
	AddFall(new Function(0,0,100,MaxEval,"max"));
	AddFall(new Function(2,0,100,modEval,"mod"));

	AddF2(enqueue, adf1, new Function(0,0,100,Arg1Eval,"arg1"));
//	AddFx(new Function(0,0,100,Arg2Eval,"arg2"));
	AddFmain(new Function(0,0,100,Aux1Eval,"aux1"));
//	AddF3(makenull, dequeue, enqueue,
//              new Function(0,0,100,inc_Aux1Eval,"Inc_Aux1"));
//	AddF3(makenull, dequeue, enqueue,
//              new Function(0,0,100,Minc_Aux1Eval,"MInc1"));
//	AddFmain(new Function(0,0,100,dec_Aux1Eval,"Dec_Aux1"));
	AddFmain(new Function(0,0,100,Aux2Eval,"aux2"));
//	AddF3(makenull, dequeue, enqueue,
//              new Function(0,0,100,inc_Aux2Eval,"Inc_Aux2"));
//	AddF3(makenull, dequeue, enqueue,
//              new Function(0,0,100,Minc_Aux2Eval,"MInc2"));
//	AddFmain(new Function(0,0,100,dec_Aux2Eval,"Dec_Aux2"));
//	AddFmain(new Function(0,0,100,Aux3Eval,"aux3"));
//	AddF3(makenull, dequeue, enqueue,
//              new Function(0,0,100,inc_Aux3Eval,"Inc_Aux3"));
//	AddF3(makenull, dequeue, enqueue,
//              new Function(0,0,100,Minc_Aux3Eval,"MInc3"));
//	AddF3(makenull, dequeue, enqueue,
//              new Function(0,0,100,dec_Aux3Eval,"Dec_Aux3"));

	AddFmain(new Function(1,0,100,readEval,"read"));
	AddF3(makenull, dequeue, enqueue,
              new Function(2,0,100,writeEval,"write"));
//	AddFx(new Function(1,0,100,write_Aux1Eval,"Write_Aux1"));
//	AddFx(new Function(1,0,100,write_Aux2Eval,"Write_Aux2"));
	AddF1(makenull, new Function(1,0,100,set_Aux1Eval,"Set_Aux1"));
	AddF1(makenull, new Function(1,0,100,set_Aux2Eval,"Set_Aux2"));
//	AddF1(makenull, new Function(1,0,100,set_Aux3Eval,"Set_Aux3"));

//	AddF(new Function(0,0,100,MakenullEval,"Makenull"));
	AddF1(dequeue,new Function(0,0,100,FrontEval,"Front"));
//	AddF(new Function(0,0,100,DequeueEval,"Dequeue"));
//	AddF(new Function(1,0,100,EnqueueEval,"Enqueue"));
//	AddF(new Function(0,0,100,EmptyEval,"Empty"));
	AddF2(dequeue, enqueue, new Function(1,0,100,Adf1Eval,"Adf1"));
//	AddF(new Function(2,0,100,Adf2Eval,"Adf2"));

	// Set some defualt parameters

	p->params[pMaxExpr]=250;	// Nb hold NUM_TREES trees
	p->params[pRepeatEval]=0;	// Dont test again if copy chrome
	p->params[pMuteShrinkWt]=0;	// No shrink mutation
	p->params[pMuteWt]=0;	        // No muation
	p->params[pCrossWt]=90;         // Use Koza value
	p->params[pMuteRate]=0;         // No mutations
	p->params[pAnnealCrossWt]=0;	// No annealing
	p->params[pAnnealMuteWt]=0;
	p->params[pTournSize]=4;	// try and see
	p->params[pKillTourn]=4;	// try and see
	p->params[pMateRadius]=0;	// whole population
	p->params[pMaxAge]=0;     	// no age limit
//	p->params[pFitnessCases]=;	// ?
	p->params[pPopSize]=1000;	// Population size
	p->params[pPopSize]=50000;	// Max number individuals to generate

	ifstream gpParams ("gp.ini");
	if ( gpParams )
	     { p->Load(gpParams);
	       gpParams.close();
             }
	else 
		cerr << "Could not open gp.ini, using defaults\n";

	// If you need to load problem specific data for evaluation
	// Or load an environment (a map, a scenario)
	// Do it here
}
//store for test cases

int first_test = 0;

const int first_test_sequence = 1;
int test[Max_tests];
retval argument[Max_tests];
retval ans[Max_tests];

int fron, rear;
retval correct_queue [test_queue_limit+1];

int addone(int i) {return (i + 1 )% test_queue_limit;}
BOOL set_answer (int i)
{
ans [i] = 0;
argument [i] = 0;

switch(test[i])
{
 case makenull:
	fron = 0;
	rear = test_queue_limit - 1;
	break;

 case front:
	if (addone(rear) == fron )
		return FALSE; //force new tested to be selected
	else
		ans [i] = correct_queue [fron];
	break;

 case enqueue:
	if (addone(addone(rear))==fron)
		return FALSE; //force new tested to be selected
	else
	       {       argument [i] = int(5*tan(float(rnd(3141))/1000.0));
		       rear = addone(rear);
		       correct_queue [rear] = argument [i];
	       }
	break;

 case dequeue:
	if (addone(rear) == fron)
	       return FALSE; //force new tested to be selected
	else
	       ans [i] = correct_queue [fron];
	       fron = addone(fron);
	break;

 case empty:
	ans [i] = (addone(rear)==fron);
	break;

 default:
	return FALSE; //force new tested to be selected
	break;
}//end case

return TRUE;

}//end set_answer()

int tests_run = 0;
float tests_avg_passed[Max_tests];

int test_total = 0;
int test_cases [empty+1] = {0, 0, 0, 0, 0};
int test_by_length [empty+1][test_queue_limit+2];
int test_Qlength [Max_tests];


float score ( int m, int f, int d, int eq, int em )
{ return m  * makenull_score +
	 f  * ( sign_score + magnitude_score ) +
	 d  * ( sign_score + magnitude_score ) +
         eq * enqueue_score +
         em * empty_score;
}//end score


void	generate_tests()
{
int i = 0;

cout << "Generating test data\n";
memset(tests_avg_passed,0,sizeof(tests_avg_passed));
memset(test_by_length,0,sizeof(test_by_length));


//enum{makenull,front,dequeue,enqueue,empty,adf1,adf2,start_test,end_tests};
const int test_seq_length [Num_test_seq]         =
	                                       { 40,
                                                 40,
                                                 40,
						 40,
						160};
const int probablities [Num_test_seq][(empty+1)] =
	                                       {  1, 20, 34, 25, 20,
                                                 30, 10, 10, 40, 10,
                                                 10, 10, 20, 30, 30,
                                                 10, 40, 20, 20, 10,
                                                  0, 11, 18, 68,  3 };//rescald
#define ptotal 100
#define test_five 4

for (int j = 0; j < Last_test_seq; j++ )
{
test[i++] = start_test;
int old_length = test_queue_limit + 1; //ie not set yet
for (int k=0; k<test_seq_length[j]; k++)
	{
assert ( i < Max_tests );//better than segmention fault
	BOOL try_again;
	do {    try_again = FALSE;
		test[i] = makenull;
		if (k != 0) 
		  {       
			  int r = rnd(ptotal);
			  for ( int m = makenull; m <= empty; m++)
				  if (r < probablities [j][m])
				   {
				     if( (j==test_five)                     &&
                                         (m==enqueue)                       && 
                                         (old_length!=test_queue_limit + 1) && 
                                         (r>=((probablities [j][m] *
                        (test_queue_limit-1-old_length))/(test_queue_limit-1)))
					)
					try_again = TRUE;
				     else 
					test [i] = m;
				     break;
				   }
				  else 
					  r -= probablities [j][m];
		  }

	   } while (try_again==TRUE || set_answer(i)==FALSE);
	test_total++;
	test_cases [test[i]]++;
	test_by_length [test[i]][old_length]++;
	test_Qlength [i] = old_length++;
	old_length = (rear+1+test_queue_limit-fron) % test_queue_limit;
       	i++;
	}//endloop k
}//endloop j
test[i++] = end_tests;

max_fitness = score (
	      test_cases [ makenull ],
	      test_cases [ front ],
	      test_cases [ dequeue ],
              test_cases [ enqueue ],
              test_cases [ empty ]    ) - 
	      1.0/10000.0; //protect against rounding errors

}//end generate_tests()

void write_Qlength(ostream& fout, int k)
{
if ( k <= test_queue_limit ) fout << k << "\t\t";
else                         fout << "undefined\t";
}
      
void write_tests ( ostream& fout = cout )
{
fout<<"\ntest cases\n";
fout << "sign_score\t" << sign_score
<< "  magnitude_score\t" << magnitude_score
<< "  empty_score\t" << empty_score
<< "\nmakenull_score\t" << makenull_score
<< "  dequeue_score as front"
<< "  enqueue_score\t" << enqueue_score
<< "\nmem_penalty\t" << mem_penalty
<< "  per word, if more than " << mem_penalty_bot
<< " words are used" << endl;


int skip = 0;

{for (int i = first_test; test[i] != end_tests; i++)
   {  if ( test [i] == start_test )
	      { skip++;
		if ( skip < first_test_sequence )
			{ for(i++;test[i] < start_test; i++); i--;}
		if ( skip == first_test_sequence )
			{ first_test = i; }
		fout << "\nstart_test\n";
	      }
      else
	     {
	      fout<< i <<"\t";
	      ThisProblem->WriteTreeName(test[i], fout);
	      fout<< "(" << argument[i] << ")  \t" << ans[i];
	      fout<< "\t" << tests_avg_passed[i] << "\t";
	      write_Qlength(fout,test_Qlength[i]); fout<<endl;
             }
   }
}
fout<< "\nRan " << tests_run << " fitness evaluations\n";

{for ( int j = 0; j <= empty; j++ )
	{
	ThisProblem->WriteTreeName(j, fout);
	fout<<" tested " << test_cases [ j ] << " times";
        if ((j == dequeue ) || ( j == empty ))
		fout<<endl;
        else
		fout<<", ";
        }
}

fout << "\nQueue length";
{for ( int j = 0; j <= empty; j++ )
{fout << "\t"; ThisProblem->WriteTreeName(j, fout);}
}
fout << "\tscore" << endl;
{for ( int k = 0; k <= test_queue_limit + 1 ; k++ )
{       write_Qlength(fout,k);
	for ( int j = 0; j <= empty; j++ )
		{ fout << test_by_length [ j ][ k ] << "\t"; }
	fout << score (
	      test_by_length [ makenull ] [ k ],
	      test_by_length [ front    ] [ k ],
	      test_by_length [ dequeue  ] [ k ],
              test_by_length [ enqueue  ] [ k ],
              test_by_length [ empty    ] [ k ]    ) << endl;
}}
fout << endl;

}//end write_tests()


void queue::WriteTreeName(int tree, ostream& ostr)
{switch(tree)
	 {
	 case makenull: ostr<< "makenul"; break;

	 case front:    ostr<< "front"; break;

	 case enqueue:  ostr<< "enqueue"; break;

	 case dequeue:  ostr<< "dequeue"; break;

	 case empty:    ostr<< "empty"; break;

	 case adf1:     ostr<< "adf1"; break;

	 case adf2:     ostr<< "adf2"; break;

	 default:       ostr<< "ERROR322"; break;
	 }
}//end queue::WriteTreeName()

BOOL queue::TreeNameMatch(int tree, char* s)
{switch(tree)
	 {
	 case makenull: return strcmp("makenul", s);
	 case front:    return strcmp("front",   s);
	 case dequeue:  return strcmp("dequeue", s);
	 case enqueue:  return strcmp("enqueue", s);
	 case empty:    return strcmp("empty",   s);
	 case adf1:     return strcmp("adf1",    s);
	 case adf2:     return strcmp("adf2",    s); 
	 default:       return FALSE;
	 }
}//end queue::TreeNameMatch()

BOOL update_score(float& score,
		  int test_done, int actual_answer, int required_ans )
{
//return TRUE => test passed.
switch(test_done)
{
 case makenull:
	score += makenull_score;
	return TRUE;

 case front:
 case dequeue:
	if ( actual_answer == required_ans )
	      { score += magnitude_score;
		return TRUE;
	      }
	else
		return FALSE;
	break;

 case enqueue:
	score += enqueue_score;
	return TRUE;
	break;

 case empty:
	if ( (actual_answer==0) == required_ans )
	      { score += empty_score;
		return TRUE;
	      }
	else
		return FALSE;
	break;

 default:
	assert (0==1);   //catch internal error and terminate gp run
        break;
}//end case
return FALSE;            //not used but keeps compiler happy
}//end update_score()

void display_run (Chrome* chrome, ostream& fout = cout )
// fitness function.
{
int i;
int passed = 0;
float score = 0.0;
memset(store_written,0,sizeof(store_written));
adf1_cache.init();

chrome->SetupEval();

for(i=first_test; test[i] != end_tests; i++)
{
if (test[i] == start_test)
	 {
	 fout<<"\nInitialise everything for new test\n";
	 memory_error = FALSE;
	 recurse_error = FALSE;
	 Aux1 = 0;
	 Aux2 = 0;
	 Aux3 = 0;
	 memset(store,0,sizeof(store));
        }
else
	{retval answer;

	 Arg1 = argument[i];
	 Arg2 = 0;
	 memset(calls,0,sizeof(calls));
	 calls [ test[i] ] = 1; //should be in evalAll, but avoid chrome.cxx
	 answer = chrome->evalAll ( test[i] );
	 if (memory_error)  fout<< "MEMORY ERR\t";
//         else
         if (recurse_error) fout<< "RECURSE ERR\t";
         else
         if ( update_score( score, test[i], answer, ans[i]) )
	       { fout<<"passed\t\t";
		 passed++;
	       }
	 else
		 fout<<"FAILED\t\t";
	 fout<<"Test ["<<i<<"] ";
	 ThisProblem->WriteTreeName(test[i], fout);
	 fout<< "(" << argument[i] << ")  \tresult " << answer;
	 fout << " (expected " << ans[i] << ")\n";
        }//end if
fout<<"score = " << score;
fout<<" Aux1 = " << Aux1;
fout<<" Aux2 = " << Aux2;
fout<<" Aux3 = " << Aux3;
fout<<" lvusd  " <<last_var_used <<endl;
for (int j = 0; j < store_limit; j++)
   {
	if ( store[j] != 0 )
	   {
	   fout<<"store " << j-(store_limit/2) << " = " << store [j] << endl;
           }
   }
//if (memory_error||recurse_error) break;
if (recurse_error) break;
}//end loop

int written = 0;
for (int j = 1; j < store_limit; j++ )
{
	if (store_written[j])
	    {   if((j-store_limit/2)%10 == 0) fout << "W"; else fout << "w";
		written++;
	    }
	else
		if((j-store_limit/2)%10 == 0) fout << "_"; else fout << " ";
}
fout << ": " << written;
fout << " size of adf1 cache " << adf1_cache.cache_used << endl;

fout<<"Final score = " << score << ". Passed " << passed << " tests.\n";

if  ( passed < test_total ) //NB fvalue frigged to stop chrome
	assert (chrome->nfitness->fvalue == float (score)); //it should be!

}//end display_run()


float queue::fitness(Chrome* chrome)
// fitness function.
{
int i;
int passed = 0;
float score = 0;
memset(store_written,0,sizeof(store_written));

tests_run++;

const float r = float(ThisParams->params[pPopSize]-1) / 
                float(ThisParams->params[pPopSize]);
for (i=first_test; test[i] != end_tests; i++)
        tests_avg_passed[i] *=r;

ptrmyfitnessvalue fitptr = ptrmyfitnessvalue (chrome->nfitness);

//NB clearing whole of myfitnessclass cause gcc produced code to crash
memset(fitptr->hits,0,sizeof(fitptr->hits));
fitptr->mem_used = 0;

adf1_cache.init();

//cout << "Fitness of "<< chrome << flush; //debug

for(i=first_test; test[i] != end_tests; i++)
{
if (test[i] == start_test)
	{
//initialise everything for new test
	 memory_error = FALSE;
	 recurse_error= FALSE;
	 Aux1 = 0;
	 Aux2 = 0;
	 Aux3 = 0;
	 memset(store,0,sizeof(store));
        }
else
	{retval answer;
	 Arg1 = argument[i];
	 Arg2 = 0;
	 memset(calls,0,sizeof(calls));
	 calls [ test[i] ] = 1; //should be in evalAll, but avoid chrome.cxx
	 answer = chrome->evalAll ( test[i] );
//	 if (memory_error)   { break;  }
	 if (recurse_error)  { break;  }

         if (update_score( score, test[i], answer, ans[i]))
	       { fitptr->hits[test[i]]++;
		 passed++;
		 tests_avg_passed[i]+= 1.0/float(ThisParams->params[pPopSize]);
	       }

        }//end if
}//end loop

for (int j = 1; j < store_limit; j++ )
{	if (store_written[j])
		fitptr->mem_used++;
}
fitptr->adf1 = adf1_cache.cache_used;

if ( passed >= test_total ) score = max_fitness; //stop chrome

chrome->nfitness->fvalue= float (score);

//cout<<"Final score = " << score << endl; //debug

return score;

}//end queue::fitness

int static_check_loop = 0; //detect loops

int queue::static_check(Chrome* chrome, int tree)
// Perform static analysis of new chromsome. Just changed in tree
// Crude but should demonstrate if the idea is worth pursuing
// Only checks Adf1
{

const int good = 0;
const int recurse_penalty = 100;
const int poor_function_penalty = 100;
//const int memory_penalty = 20;

//store_written - not used directly by static_check

if (tree!=adf1) return good;

static_check_loop++;
if(static_check_loop > 1000)
{   cout<<"static_check looping! ("<<static_check_loop<<")"<<endl;
    static_check_loop = 0;
    chrome->write(PRETTY_NONE,cout); cout<<endl;
    return good;               //stop it looping
}

const int num_checks = 2*(Max + 1);

//cout<<"static_check (ADF1) "<<static_check_loop<<flush; //debug

retval ans [num_checks];

ptrmyfitnessvalue fitptr = ptrmyfitnessvalue (chrome->nfitness);

fitptr->adf1   = 0; //assume the worst
BOOL follow    = FALSE;
BOOL new_value = FALSE;
int  k         = -1;
for (int i = 0; (k<Max) && (i<num_checks); i++)
       {//start call adf1 loop
	 int input;
	 if (!follow && new_value && (ans[i-1] < 0 || ans[i-1] > Max) )
         {  input = ans[i-1];
	    follow = TRUE;
         }
	 else
         {  input  = ++k;
	    follow = FALSE;
         }

	 //initialise everything to be consistent with queue::fitness

	 memory_error = FALSE;
	 recurse_error= FALSE;
	 Aux1 = 0;
	 Aux2 = 0;
	 Aux3 = 0;
	 memset(store,0,sizeof(store));

	 Arg1 = input;
	 Arg2 = 0;
	 memset(calls,0,sizeof(calls));
	 calls [ tree ] = 1; //should be in evalAll, but avoid chrome.cxx

	 chrome->SetupEval();
	 ans [i] = chrome->evalAll ( tree );

//if(recurse_error)cout<<" RECURSE_ERROR";
//if(memory_error) cout<<" MEMORY_ERROR";
//cout<<" "<<Arg1<<"=>"<<ans[i]<<" "<<flush;

//cout<<" "<<last_var_used<<" "<<arg1_used<<" "<<arg1_side_effect<<" ";

	 if (recurse_error)  return recurse_penalty;

         new_value = TRUE;
	 for (int j = 0; j < i; j++)
	 {
		 if (ans[i] == ans[j]) new_value = FALSE;
	 }
	 if (new_value) fitptr->adf1++;

	if (ans[i] == i) return poor_function_penalty; //identity
        };//end run adf1 to test it loop


if (fitptr->adf1 <= 1)
	return poor_function_penalty; //ie its a constant
else
  {
//chrome->write(PRETTY_NONE,cout); cout<<endl; //debug
        static_check_loop = 0;
	return good;
  }
}//end queue::static_check



int Is_adf1_minc(Chrome* chrome)

// Call adf1 repeatedly, untill either it returns an answer it has
// already given before or one that is not a legal memory address.
// If adf1 falls into a cycle return the cycle length

{

retval ans [store_limit+2];
ans[0] = 0;

chrome->SetupEval();

for (int i = 0; i <= store_limit; i++)
       {
	 Arg1 = ans[i];
	 ans [i+1] = chrome->evalAll ( adf1 );

	 if ((ans[i+1]+(store_limit/2) <= 0) || (ans[i+1] >= store_limit/2))
		 return 0;

	 for (int j = 0; j <= i; j++)
		 {if (ans[i+1] == ans[j]) return i+1-j;}

        };//end run adf1 to test it loop

assert(1==0); //should never fall out of loop
return 0; //keep compiler quiet
}//end Is_adf1_minc

void test_all_adf1(Pop* pop, int lower)
{
int v, x, y;

if (ThisParams->params[pPopWidth] == 0)
   for (x=0;x<ThisParams->params[pPopSize];x++) {
	v = Is_adf1_minc(pop->pop[x] );
	if (v >= lower) {
		cout<< x << " " << v;
//		pop->pop[x]->write(PRETTY_NONE,cout);
		cout<<endl;
	}
   }
else
   for ( y=0; y <= (ThisParams->params[pPopSize] / 
		    ThisParams->params[pPopWidth]); y++) 
   for ( x=0; (x < ThisParams->params[pPopWidth]) && 
	      ((x+y*ThisParams->params[pPopWidth]) < 
		      ThisParams->params[pPopSize]);   x++) {
	v = Is_adf1_minc(pop->pop[x+y*ThisParams->params[pPopWidth]] );
	if (v >= lower) {
		cout<< x << " " << y << " " << v;
//		pop->pop[x+y*ThisParams->params[pPopWidth]]->
//			write(PRETTY_NONE,cout);
		cout<<endl;
	}
   }
}//end test_all_adf1;

void display_all_best(Pop* pop, int popsize, int popwidth)
{
int i, dummy;
int outputsize = 50;
int output[50 /*outputsize*/];
int duplicates[50 /*outputsize*/];

select_hits(
pop->pop, popsize, 0, &dummy, TRUE, output, duplicates, &outputsize);

cout<<"Best ("<<outputsize<<") in population "<<endl;

for (i=0; i<outputsize; i++){
	if (popwidth == 0) {
		cout<< output[i] << " ";
		pop->pop[output[i]]->nfitness->write();
	}
	else {
		cout<< output[i] % popwidth << " " 
		    << output[i] / popwidth << " ";
		pop->pop[output[i]]->nfitness->write();
	}
	cout<<endl;
}//end display best in pop

}//end display_all_best();

//void write_fitness_summary()
//{
//
//};//end write_fitness_summary




//**************************************************************************
int do_gens (Pop* pop, int number, int tree) //return if complete or not
{    
     cout << "Running, gpquick_seed " << gpquick_seed
          << " at " <<pop->gencount+1 << ". ";
     if ( tree >= 0 )
	  {  cout << "Crossover in ";
             ThisProblem->WriteTreeName(tree);
          }
     else
	     cout << "Random crossover tree\n";

     pop->go_until(0,number,max_fitness,tree);

     // Display the best so far
     cout << "\n\nAfter " << pop->gencount+1;
     cout << " generates, BestFitness = ";
     cout << pop->BestFitness->fvalue
          << " max_fitness = " << max_fitness << "\n";

#ifdef TRACE
     cout << pop->BestMember;
     pop->pop[pop->BestMember]->write_trace();
//   pop->pop[pop->BestMember]->write(PRETTY_NONE,cout);
     cout << endl;
#endif

//     write_tests();
     display_all_best(
	 pop, ThisParams->params[pPopSize], ThisParams->params[pPopWidth]);
     pop->DisplayStats();
     if ( ThisParams->params[pTrace] & pTraceDStats ) pop->DisplayDStats();

//     display_run(pop->best()); //show what it does
//     test_all_adf1(pop, 1);
     return (pop->BestFitness->fvalue >=max_fitness);

}//end do_gens()
///////////////////////////////  MAIN

int main(int argc, char * argv[])
// Run queue

{
	time_t start, end;

	cout << "\nGP to evolve a Queue2, "<<main_version;
	time (&start);
	cout << ", " << ctime(&start) <<endl;

	ThisProblem=new queue(ThisParams);
	for(int i=0; i<argc;i++) {
		ThisParams->Load(argv[i]); }
	Pop* pop;


	if ( ThisParams->params[pTestSeed] > 0 ) 
		gpquick_seed = ThisParams->params[pTestSeed]; //dirty I know
	else
	      { rndomize(); //use random seed
		ThisParams->params[pTestSeed] = gpquick_seed; //record seed
	      }

	generate_tests();    //Must be done before create pop
	cout<<"Number of tests " << test_total;
	cout<<". Min expected score " << 0;
	cout<<" Good score " << max_fitness - 
                        ((test_cases [ front ] + test_cases [ dequeue ]) *
                         (sign_score + magnitude_score));
	cout<<" Top score " << max_fitness;
	cout<<endl<<endl;

	if ( ThisParams->params[pPopSeed] > 0 )
		gpquick_seed = ThisParams->params[pPopSeed];  //dirty I know
	else
	      { rndomize(); //use random seed
		ThisParams->params[pPopSeed] = gpquick_seed; //record seed used
	      }

	ifstream gpLoad ("gp.load");
	if ( gpLoad )
	     { cout << "Loading from one chrome from gp.load\n";
	       ThisParams->params[pPopSize]=1;
	       ThisParams->params[pGenerateLimit]=1;
             }

	int pop_size = ThisParams->params[pPopSize];
	int gen_max  = ThisParams->params[pGenerateLimit];

	cout << "Creating new population of " << pop_size<< " individuals\n";
	pop = new Pop(ThisProblem,ThisParams,pop_size);
	cout << "new Pop -- completed\n";

	ThisParams->Save();

	int done;
	if ( gpLoad )
	     { cout << "Overwritting with file gp.load\n";
	       int rval = pop->pop[0]->Load(gpLoad, TRUE);
	       if (rval != 0)
		       cout<<"Load error - "<<rval<<endl;
	       else
		   {   pop->pop[0]->SetupEval();
		       ThisProblem->fitness(pop->pop[0]);
		       pop->pop[0]->write_trace();
		       pop->pop[0]->write(PRETTY_NONE,cout);
		       adf1_cache.stats_init();
		       display_run (pop->pop[0]);
//		       test_all_adf1(pop, 0);
	           }
	       gpLoad.close();
	       done = TRUE;
        }
else
{
	cout << "Setting each fitness value\n";
	done = do_gens (pop, pop_size-1, -1); //no crossover on init pop
	

	cout << "Initial fitness values calculated,\n";
	cout << "Creating a total of " << gen_max << " individuals\n";

	                         // kbhit IS NOT PORTABLE (Borland specific)
	while ( (pop->gencount+1) < gen_max && !done && !kbhit() )  
	{
		done = do_gens (pop, pop_size, -1);
	}


	// Display the best
	cout << "\n\nFINAL RESULTS. After " << pop->gencount+1;
        cout << " generates, BestFitness = ";
        cout << pop->BestFitness->fvalue 
             << " max_fitness = " << max_fitness << "\n";

	// Display the final population
	if ( ThisParams->params[pTrace] & pTraceStatic )
	  {  cout << "\n\nFINAL Population";
	     pop->Write();
          }

	cout << "BestMember ";
#ifdef TRACE
	cout << pop->BestMember;
        pop->pop[pop->BestMember]->write_trace();
#endif
	pop->pop[pop->BestMember]->write(PRETTY_NONE,cout);

//	write_tests();
        display_run(pop->best()); //show what it does

}//if not loading from file

	adf1_cache.write();

	time (&end);
	cout << "\nGP Queue2 took " << end - start << " secs. Finished at ";
	cout << ctime(&end);
//	cout << clock() << " ticks cpu";
	cout << endl;

	delete pop;
	delete ThisProblem;
	delete ThisParams;	
        return done? 1 : 0;
}
