############################################################################
#
#       Project		GP queue2 program using MODIFIED gpquick-2.1,
# 			using UCL GNU/Unix/etc $Revision: 1.5 $ 
#	    
#       Author		W.Langdon
#
#	Created		25 June 1994, based upon queue.make Revision: 1.2
# 									   
#	Modifications:  
#			WBL 24 Aug 94 Add pareto.cc
#			WBL 22 Aug 94 Add queue2.h
#			WBL  1 Jul 94 Add stats
#			WBL           Add -O2 to CFLAGS
#			
#
#	Module:         queue2.make     
#
#	Description:          
#
#	FLAGS:     	-DTWOD?
#			-DDEBUG, if debugging messages should pop up?
#
#	Notes		ensure pch.h contain #define UNIX
#			chrome.h #define MULTREE
#
############################################################################

NAME 	= queue2
SOURCES = queue2.cc stats.cc pareto.cc chrome.cxx primitiv.cxx selector.cxx
OBJS 	= queue2.o  stats.o  pareto.o  chrome.o   primitiv.o   selector.o
LIBS 	= -lg++ -lm
CC 	= gcc
COMPILE = $(CC) -c $(CFLAGS)
CFLAGS 	= -O2 -ansi -g -Wall
#CFLAGS = -O2 -fkeep-inline-functions -ansi -g -Wall
LINK 	= $(CC) -o 
LDFLAGS =  -g -Wall
#LDFLAGS = -static


$(NAME):$(OBJS) 
	$(LINK) $(NAME) $(OBJS) $(LDFLAGS) $(LIBS)

#C++ source files

queue2.o:	queue2.cc pch.h chrome.h queue.h primitiv.h queue2.h
	$(COMPILE) queue2.cc

stats.o:	stats.cc pch.h chrome.h selector.h queue.h queue2.h
	$(COMPILE) stats.cc

pareto.o:	pareto.cc pch.h chrome.h selector.h queue.h queue2.h
	$(COMPILE) pareto.cc

chrome.o:	chrome.cxx pch.h chrome.h selector.h queue.h
	$(COMPILE) chrome.cxx

primitiv.o:	primitiv.cxx pch.h chrome.h selector.h queue.h primitiv.h
	$(COMPILE) primitiv.cxx

selector.o:	selector.cxx pch.h selector.h
	$(COMPILE) selector.cxx
